//-3D---------------------------------------------------------------------------
// test1 3D
__kernel void simple3d_test1(const __global float* in,
                             uint4   in_size,
                             __global float* out,
                             uint4   out_size)
{
  uint3 index;
  index.x = get_global_id(0);
  index.y = get_global_id(1);
  index.z = get_global_id(2);

  bool isValid = true;
  if(index.x >= out_size.x) isValid = false;
  if(index.y >= out_size.y) isValid = false;
  if(index.z >= out_size.z) isValid = false;

  if(isValid)
  {
    uint gidx = out_size.x *(index.z * out_size.y + index.y) + index.x;
    out[gidx] = 1;
  }
}

// test2 3D
__kernel void simple3d_test2(const __global float* in,
                             uint4   in_size,
                             float4  f11,
                             float4  f12,
                             float16 a1,
                             float16 b1,
                             float16 c1,
                             __global float* out,
                             uint4   out_size,
                             float4  f21,
                             float4  f22,
                             float16 a2,
                             float16 b2,
                             float16 c2)
{
  uint3 index;
  index.x = get_global_id(0);
  index.y = get_global_id(1);
  index.z = get_global_id(2);

  bool isValid = true;
  if(index.x >= out_size.x) isValid = false;
  if(index.y >= out_size.y) isValid = false;
  if(index.z >= out_size.z) isValid = false;

  if(isValid)
  {   
    uint gidx = out_size.x *(index.z * out_size.y + index.y) + index.x;
    out[gidx] = 1;
  }
}

// test3 3D
__kernel void simple3d_test3(const __global float* in,
                             uint4  in_size,
                             uint2  f11,
                             uint2  f12,
                             uint4  a1,
                             uint4  b1,
                             uint4  c1,
                             uint8  d1,
                             uint8  e1,
                             __global float* out,
                             uint4  out_size,
                             uint2  f21,
                             uint2  f22,
                             uint4  a2,
                             uint4  b2,
                             uint4  c2,
                             uint8  d2,
                             uint8  e2)
{
  uint3 index;
  index.x = get_global_id(0);
  index.y = get_global_id(1);
  index.z = get_global_id(2);

  bool isValid = true;
  if(index.x >= out_size.x) isValid = false;
  if(index.y >= out_size.y) isValid = false;
  if(index.z >= out_size.z) isValid = false;

  if(isValid)
  {
    uint gidx = out_size.x *(index.z * out_size.y + index.y) + index.x;
    out[gidx] = 1;
  }
}

// test4 3D
__kernel void simple3d_test4(const __global float* in,
                             uint4  in_size,
                             float4 f11,
                             float4 f12,
                             float8 a11, float8 a12,
                             float8 b11, float8 b12,
                             float8 c11, float8 c12,
                             __global float* out,
                             uint4  out_size,
                             float4 f21,
                             float4 f22,
                             float8 a21, float8 a22,
                             float8 b21, float8 b22,
                             float8 c21, float8 c22)
{
  uint3 index;
  index.x = get_global_id(0);
  index.y = get_global_id(1);
  index.z = get_global_id(2);

  bool isValid = true;
  if(index.x >= out_size.x) isValid = false;
  if(index.y >= out_size.y) isValid = false;
  if(index.z >= out_size.z) isValid = false;

  if(isValid)
  {
    uint gidx = out_size.x *(index.z * out_size.y + index.y) + index.x;
    out[gidx] = 1;
  }
}

// test5 3D
__kernel void simple3d_test5(const __global float* in,
                             uint4  in_size,
                             float16 a10, float16 a11, float16 a12, float16 a13, float16 a14,
                             float16 a15, float16 a16, float16 a17, float16 a18, float16 a19,
                             __global float* out,
                             uint4  out_size,
                             float16 a20, float16 a21, float16 a22, float16 a23, float16 a24,
                             float16 a25, float16 a26, float16 a27, float16 a28, float16 a29)
{
  uint3 index;
  index.x = get_global_id(0);
  index.y = get_global_id(1);
  index.z = get_global_id(2);

  bool isValid = true;
  if(index.x >= out_size.x) isValid = false;
  if(index.y >= out_size.y) isValid = false;
  if(index.z >= out_size.z) isValid = false;

  if(isValid)
  {
    uint gidx = out_size.x *(index.z * out_size.y + index.y) + index.x;
    out[gidx] = 1;
  }
}

//-2D---------------------------------------------------------------------------
// test1 2D
__kernel void simple2d_test1(const __global float* in,
                             uint2   in_size,
                             __global float* out,
                             uint2   out_size)
{
  uint2 index;
  index.x = get_global_id(0);
  index.y = get_global_id(1);

  bool isValid = true;
  if(index.x >= out_size.x) isValid = false;
  if(index.y >= out_size.y) isValid = false;

  if(isValid)
  {
    unsigned int gidx = out_size.x * index.y + index.x;
    out[gidx] = 1;
  }
}

// test2 2D
__kernel void simple2d_test2(const __global float* in,
                             uint2   in_size,
                             float2  f11,
                             float2  f12,
                             float16 a1,
                             float16 b1,
                             float16 c1,
                             float16 d1,
                             __global float* out,
                             uint2   out_size,
                             float2  f21,
                             float2  f22,
                             float16 a2,
                             float16 b2,
                             float16 c2,
                             float16 d2)
{
  uint2 index;
  index.x = get_global_id(0);
  index.y = get_global_id(1);

  bool isValid = true;
  if(index.x >= out_size.x) isValid = false;
  if(index.y >= out_size.y) isValid = false;

  if(isValid)
  {
    unsigned int gidx = out_size.x * index.y + index.x;
    out[gidx] = 1;
  }
}
